#!/bin/sh

. livecd-functions
. shell-config

slideshow_conf='/etc/alterator/slideshow.conf'

mem=$(cat /proc/meminfo | grep MemTotal | egrep -o '[0-9]+')

if [ "$mem" -le 500000 ] ; then
	# Don't bring up slideshow.
	if [ -s "$slideshow_conf" ]; then
		shell_config_set "$slideshow_conf" url /var/empty
	else
		# Just remove slideshow if there is no config file
		rm -fr /usr/share/install2/slideshow/*
	fi
else
	url="$(shell_config_get "$slideshow_conf" url)"
	url="${url:-/usr/share/install2/slideshow}"
	# Setup proper localized slideshow
	lang=$(sed -n 's/^.*lang=\([^ ]*\).*/\1/gp' /proc/cmdline)
	lang="${lang%%_*}"

	if [ -n "$lang" -a -d "$url-$lang" ]; then
		shell_config_set "$slideshow_conf" url "$url-$lang"
	fi
fi
