(document:surround "/std/frame")

;;; UI

(box
  orientation "vertical"
  margin 10
  (document:id sl (slideshow))
  (label name "stage")
  (document:id progress (progressbar maximum 100 value 0 visibility #f))
  (label name "status" text-wrap #t))


;;; logic

(define (ui-stop)
  (remove-mailbox ui-callback))

(define (ui-done)
  (ui-stop)
  (frame:next))

(define (ui-error reason)
  (ui-stop)
  (form-update-value "stage"
                     (bold (_ "Fatal error")))
  (form-update-value "status"
                     reason))


(define (ui-stage stage)
  (form-update-value "status" "")
  (case stage
    ((install)   (progress visibility #t)))
  (form-update-value "stage"
                     (bold
                       (case stage
                         ((install)(_ "Installing system..."))
                         ((preinstall) (_ "Preparing..."))
                         ((postinstall) (_ "Finishing..."))
                         ((done) (_ "Installation is done"))))))

(define (ui-callback args)
  (case (car args)
    ((stage)
     (let ((stage (string->symbol (cadr args))))
       (ui-stage stage)
       (and (eq? stage 'done) (ui-done))))
    ((error)
       (ui-error (cadr args)))
    ((status)
     (let ((percent (cadr args)))
     (progress text (string-append percent "%"))
     (progress value percent)))))

(define (slideshow-config)
  (catch/message
	(lambda()
	  (let ((config (woo-read-first "/livecd-install/slideshow-config")))
		(sl step (woo-get-option config 'step))
		(sl once (woo-get-option config 'once))
		(sl url (woo-get-option config 'url))))))

;;;;;;
;;; Notify backend to start unpack squashfs
;;;
(define (ready)
  (catch/message
    (lambda()
     (woo-write "/livecd-install"))))

(document:root
  (when loaded
    (frame:next-activity #f)
    (frame:back-activity #f)
    (add-mailbox ui-callback)
    (slideshow-config)
    (sl start #t)
    (ready)))
